#/bin/sh

clear

Codec=""
CodecFiles="/tmp/mdzALC"
DIR=$(perl -e 'use Cwd "abs_path"; print abs_path(@ARGV[0])' -- "$0" | rev | cut -f2- -d"/" |rev)
Files="$(echo $DIR)/Files"
Resources="$(echo $DIR)/Files/AppleALC"


echo "Willkommen bei dem automatisierten Compiler für eine OZ/BIOS-geeignete AppleALC-Version by MODzilla!"
echo "Stelle bitte vorher sicher, ob Xcode Command-Line Tools + Git installiert sind, da es sonst zu Komplikationen kommen würde!"
read -p "Welcher Audio Codec wird benötigt? (z.B. ALC892; VT2020_2021) =" Codec

rm -r "$CodecFiles"
mkdir "$DIR/Files"
mkdir -p "$CodecFiles"
cd "$Files"
git clone https://github.com/vit9696/Lilu.git
git clone https://github.com/vit9696/AppleALC.git
cd "$Files/Lilu"
xcodebuild
xcodebuild -configuration Debug

cd "$Files"
cp -r "$Files/Lilu/build/Debug/Lilu.kext" "$Files/AppleALC/"
cp -r "$Files/Lilu/build/Release/Lilu.kext" "$DIR"
rm -r "$Files/Lilu/build"


mv "$Resources/Resources/" "$CodecFiles"

mkdir "$Resources/Resources"
cp "$CodecFiles/Resources/CodecLookup.plist" "$Resources/Resources/"
cp "$CodecFiles/Resources/Kexts.plist" "$Resources/Resources/"
cp "$CodecFiles/Resources/Vendors.plist" "$Resources/Resources/"
cp "$CodecFiles/Resources/Controllers.plist" "$Resources/Resources/"
cp -r "$CodecFiles/Resources/PinConfigs.kext" "$Resources/Resources/"

cd "$Resources"
xcodebuild

cp -r "$CodecFiles/Resources/$Codec" "$Resources/Resources/"


cp -r "$Files/AppleALC/build/Release/AppleALC.kext" "$Files"
cp -r "$Files/AppleALC.kext" "$Files/AppleALC_Pinconfig_unmerged.kext"


echo ""
echo "Zusammenführen der PinConfig.kext in die Info.plist (all credits to cecekpawon for that script)!"
echo ""


gPlistBuddyCmd="/usr/libexec/plistbuddy -c"
AppleALC="$Files/AppleALC.kext"
ALCContents="${AppleALC}/Contents"
ALCPlist="${ALCContents}/Info.plist"
ALCPlugIns="${ALCContents}/PlugIns"
ALCPinConfigs="${ALCPlugIns}/PinConfigs.kext"
ALCPinConfigsPlist="${ALCPinConfigs}/Contents/Info.plist"


$gPlistBuddyCmd "Add ':Tmp' dict" "$ALCPlist"
$gPlistBuddyCmd "Merge "${ALCPinConfigsPlist}" ':Tmp'" "$ALCPlist"
$gPlistBuddyCmd "Copy ':Tmp:IOKitPersonalities:HDA Hardware Config Resource' ':IOKitPersonalities:HDA Hardware Config Resource'" "$ALCPlist"
$gPlistBuddyCmd "Delete ':Tmp'" "$ALCPlist"
$gPlistBuddyCmd "Delete ':OSBundleLibraries:as.vit9696.PinConfigs'" "$ALCPlist"

rm -rf "$ALCPlugIns"

mv "$Files/AppleALC.kext" "$DIR"
rm -rf "$Files"

echo "Done!"

echo ""

echo "Um die Kext nochmals zu verkleinern müssen zudem noch alle ungenutzten PinConfigs aus der Info.plist gelöscht werden! Hierfür wird sich sogleich der Standarteditor mit der Plist öffnen!"

echo "Unter IOKitPersonalities/HDA Hardware Config Resource/HDAConfigDefault/ müssen diese gelöscht werden!"
echo "


open -a TextEdit "$DIR/AppleALC.kext/Contents/Info.plist"

exit 0
